aboutsummaryrefslogtreecommitdiff
path: root/net-fs
diff options
context:
space:
mode:
authorAnthony G. Basile <blueness@gentoo.org>2016-05-28 09:47:06 -0400
committerAnthony G. Basile <blueness@gentoo.org>2016-05-28 09:47:06 -0400
commitfbb0cc1418419103a3d12838351fc640d27cc299 (patch)
tree9275516d8be608c85a9f57a6f7576ba35e09ba33 /net-fs
parentsys-apps/attr: add missing <sys/types.h> to <attr/attributes.h> for u_int32_t (diff)
downloadmusl-fbb0cc1418419103a3d12838351fc640d27cc299.tar.gz
musl-fbb0cc1418419103a3d12838351fc640d27cc299.tar.bz2
musl-fbb0cc1418419103a3d12838351fc640d27cc299.zip
net-fs/samba: added for testing
Package-Manager: portage-2.2.28
Diffstat (limited to 'net-fs')
-rw-r--r--net-fs/samba/Manifest15
-rw-r--r--net-fs/samba/files/4.3/samba4.confd38
-rw-r--r--net-fs/samba/files/4.3/samba4.initd-r156
-rw-r--r--net-fs/samba/files/nmbd.service12
-rw-r--r--net-fs/samba/files/samba-4.2.3-heimdal_compilefix.patch22
-rw-r--r--net-fs/samba/files/samba-4.2.7-pam.patch36
-rw-r--r--net-fs/samba/files/samba.conf2
-rw-r--r--net-fs/samba/files/samba.service10
-rw-r--r--net-fs/samba/files/smbd.service12
-rw-r--r--net-fs/samba/files/smbd.socket9
-rw-r--r--net-fs/samba/files/smbd_at.service7
-rw-r--r--net-fs/samba/files/winbindd.service12
-rw-r--r--net-fs/samba/metadata.xml32
-rw-r--r--net-fs/samba/samba-4.3.9-r99.ebuild250
14 files changed, 513 insertions, 0 deletions
diff --git a/net-fs/samba/Manifest b/net-fs/samba/Manifest
new file mode 100644
index 0000000..7f77a4a
--- /dev/null
+++ b/net-fs/samba/Manifest
@@ -0,0 +1,15 @@
+AUX 4.3/samba4.confd 1783 SHA256 53755809cc27fdbaf98752cd3da45b5c2bda62dd46fcc37570c6e237f7954ffa SHA512 6fc7edf192957f97b171c97482317bf563385917cfdbf950ed28d9387961bd16f82844c6f9b5c430508ec6dc7331ecdf5f81fa3135663316061c1d0b1808f53d WHIRLPOOL 868539ecf658f9da3574847cb1447dafe422c60a9208de5580cf7f53e4346e9c7d1c6b3e7ea5c684b83e613dd912c5245ffce6a43bc8bd9bf8417a9c7a5f2557
+AUX 4.3/samba4.initd-r1 1110 SHA256 44b53a5d5f516cb944a308613579b3e8e2716651961274b0b01afc70feede342 SHA512 f69c400d08be6f19864d06ea2a0b3518804b5ad64deac0279b2ad17827b51ef2170bb5b7ef57e8b7041170c66dc7c362f847d2eca0275b74c13adfa156055253 WHIRLPOOL f45d26e8e3f3b86459ee0b4447eab4d585ed025e1f62971dfa48013921d1473c50f0c7aab5b002b7ec6e41281a6638a86ec7188b19773407d15ff1da05215801
+AUX nmbd.service 224 SHA256 a5e25c11714206c4fb129333dd45152c5753716c6445cbe78c28275df1a1cb77 SHA512 098dfb270c5a5c29f59b4fd8d51b17931771e25e481124832f1a086677825527e2afa7276e8614e5007fbf044d253ce2eaf3a7caf7461ad5d90d0b1c7f157f9d WHIRLPOOL 2f7c342a60c09d5e40e968a026aa17d8c2fe3fd032331c7bb26599bb0f8ec8a77c2a3e329498ed16b1602451fd85a8ef076c436e8a092740cfbd01a82ca52e30
+AUX samba-4.2.3-heimdal_compilefix.patch 819 SHA256 6cf93d127aa900c1e9a4fb8a3bdff6054d78a7adb798c6f409feffc13c714ee9 SHA512 0f6ddbf58e5d5b83e3fb9738dd10c2ab0f1ed96fb62f9b4389a40729b3fe2d4af1a5c5bd2d44fa7d568136072b787b6358aeca3026f1acec4f5a6869e74f2536 WHIRLPOOL 882a52598013a40165d87616eaa016139fa89ff218dc43a6e6518123ccc18ca84e4ba275731e10ec762b22f26576eac56ad6b257cfae2e1cbc45f518a0d37007
+AUX samba-4.2.7-pam.patch 1273 SHA256 e1abd99fcf4ff721dafa64c77a60b07962e3e818eaf5d10fecead61a2af81e07 SHA512 5f900ebfdfb15af38814864f7ec8cd52d3525098d6f2017ab2f29d301e6a0e622d2ab37976fbd97180cbfe23c7853e91ab7966655eb46ebd9bdd2951205e46bc WHIRLPOOL 91e1fc2e49944d1ded93d902fc50437763388a12b8c2eab70e2dcd8124860746c71fa8b4c26e7b43e5ebc2c0fc94c4c005a2c1eb8b9af68e77c9c6cc1d92927c
+AUX samba.conf 61 SHA256 e4fc68bc14a44e3c452e767d996ff693d131da317eb513de10d752dd96cb6f12 SHA512 4a75185762c90d110c399215fbfc939d30804b558ffdb11cc68dee6f87a94c86cadbcd63935884db1266cf40fe24fefb75f9067fe4751ad9838d7a43e8973b9e WHIRLPOOL ad21bc3738c2ec721ad3be746c66719385390835c7f4da881fc0cc1c982bb6821a56300157b1169d1a35264e44dab1a0c29cd9919455a02a8f4c53c665a4bed3
+AUX samba.service 199 SHA256 0ae738fa2a15b476dbca016dfa4e1cf4b8c4a575e13edf518eb70b615c02a059 SHA512 eb277917f15de958f4a0404b66c6d2cc82ae4319b85f2f442489988d523bf92e2a9d23a6051ee693cd4bcfbc67947e8028c59906ad3e537578daf5caee8a6f16 WHIRLPOOL 1132081b63b1e0e1a9342d59493ebfe1d918133a4091e48c42dae7845dcaa24a0b8e7a1183d5a41b0173c3f6dbc17838a9b7a6297fc8ea0775ab150a22ae3151
+AUX smbd.service 250 SHA256 e1f5da902cd97891852f6463b2c7eddbc61e7fbd3e3c281028a806319627fc68 SHA512 a54e3c337f7c27766a81f68ad6d8f4eb6ddb1d1aec3303f274e419a49114755bc5dd711701d5e64954ae7153a8be4a7063371af286696c0b81d543b9276703c3 WHIRLPOOL 18b6a57603a41303d207249fdb46cb4f6e887f8b9bd4921dca6b4f28a59951368d6abead2dc9d3be2c09cb2c9f295087ef5f20d121a309791b9031e3fad28b13
+AUX smbd.socket 121 SHA256 d62a239cba39ae03dbb7a291843b2c202973341c85d93ffc87b4e78813be44c2 SHA512 2db4a707fcc6ef1928ac010e5e92cdaf0f6ff3ffa8aef918e0db1ce910abfb481d6a19082337f9c8444cd780d1d442fa8df2bb65e6142fc109d29657532572ed WHIRLPOOL aef792f27a7cd91ee258b6137015269cf2e6310c24a060acb7c6a97162aaebe37f32f66e46f4399cd1160bcc65e5608da7bc87bf933bccd2ffdfe51a6a7cdd8d
+AUX smbd_at.service 145 SHA256 909dddfd80982035739081d86d2c524f6a25440d9c10b8a80626d9b4eee424cd SHA512 e6486c35dfa6f77ad46547a78fcae55fb71e4dad7dc7b4580c2b8c1be232c0a870f56714b2b103a1fd8717298f41347d7178fbebb90f0f2d0324fe5233f0f9f3 WHIRLPOOL f5ac03a1e7b653458d49fa2c2afe674e9d8f1e5a81e72a5e49781de3e5111bbe23eedc38c78a6f5e7edc4c32300ddaf76caf889de256fc799cf117edcd6ce6fb
+AUX winbindd.service 240 SHA256 755036bc419cce90200ac3c04986fbb7cf718c128c2a1288c634658bb779bf3a SHA512 f1ce6d035e8e0fcdc73f14e3b60c9647043777ff6b2a982a81ed07eb4df5ff245a9511e3e4a9d8163f9c8f3fb86d2a39a67621ace68392eb7c2f2e2a55d587f7 WHIRLPOOL eb4d7f30b4ce3341e3d24a6c05965bdce9ded78a7327b44d3d04d00837d6e8109857b1fb1b78c8325680588cf9abe94158755a962fb8f7e8dac04b336308c268
+DIST samba-4.3.9.tar.gz 20570849 SHA256 1f22c61a7f24c5357a9ef4d10833a2cd161f40f3db03bcbe586d7cd3a56139f3 SHA512 bc90c88d8defd3acec7c671e8ceacec31e3111540aabee7ec6f11cdeaf61bbd993525e2b765e3b50801c8079e1168cf496b3e5e6a56118d6493ae5da60d34c41 WHIRLPOOL e33efba4bfbaab5278ec62cbadb5f14fe2220d4b4ad1e57a4d26233d8b6bdf4318ad86d839b2638a490a195c04aabb02dafff67bb1e2999fab4f116b3c6367cc
+DIST samba-disable-python-patches-4.3.9.tar.xz 6116 SHA256 83206112e04c375e170e86ea6b29d6dc2c172b55ba9fb89130be14708d758cf5 SHA512 ca8b62337afd1cc6059b9aefc0a3972d18ba90fba3f043d9730f6967e1b80c40bc918b0445b8ae8a1f3df74d3551f90c721df3c0514edccb881ed0b4fc54e1b5 WHIRLPOOL 3aebd6758e5e7dc2920b1e8f8825d2b7b7efac7c5f2d91d5ed6fed75597bfdced1b27d9e2a00385af5df19e5462a4e014df6a7274c0b25a660702268235ef746
+EBUILD samba-4.3.9-r99.ebuild 6684 SHA256 9cc9763e58a0b6cf537287eefd98b1ad0ef33106ab3f61e4398141f4fe644d0f SHA512 00764d3a3ec15f0e47e4d3ed9e83fdc665ffc685b93ab58798c0eb920d7f067cdec99037b7641b4a7d28ffd4b9d6e6ea1a07df83f9f2f479456327ac18c4f9a9 WHIRLPOOL 70e120156cd09100b1c930f94d89aa09a53b256e04641d0ee089abd31cb64cf6fd9b86c1a08f270e1196eb82fb9d4597bc75d64277a695f43564d3e1bdd03970
+MISC metadata.xml 1714 SHA256 94b726fc2c6f741402a9a6139fd507a9b7b56d0920ae83a095e0e5c416250f3d SHA512 ccf8143ca9c586a5313f8e4d82ae9114ad9685def8b12729804ebd5279ce53e58685cf21257a7fe11f0a40227df5b3987550d4d8f3fde1752310eec3da27ba4f WHIRLPOOL 7c35b3a07535c0e3e9e716a394f06535c343a44dcd4ec49c28460ef337e9d920fc91210f083bf6ca098774369bec065e280ef11f296372242ea94b72b70a9fc2
diff --git a/net-fs/samba/files/4.3/samba4.confd b/net-fs/samba/files/4.3/samba4.confd
new file mode 100644
index 0000000..58b2c78
--- /dev/null
+++ b/net-fs/samba/files/4.3/samba4.confd
@@ -0,0 +1,38 @@
+# Add "winbind" to the daemon_list if you also want winbind to start.
+# Replace "smbd nmbd" by "samba4" if you want the active directory domain controller part or the ntvfs
+# file server part or the rpc proxy to start.
+# Note that samba4 controls 'smbd' by itself, thus it can't be started manually. You can, however,
+# tweak the behaviour of a samba4-controlled smbd by modifying your '/etc/samba/smb.conf' file
+# accordingly.
+daemon_list="smbd nmbd"
+
+#----------------------------------------------------------------------------
+# Daemons calls: <daemon_name>_<command_option>
+#----------------------------------------------------------------------------
+my_service_name="samba"
+my_service_PRE="unset TMP TMPDIR"
+my_service_POST=""
+
+#----------------------------------------------------------------------------
+# Daemons calls: <daemon_name>_<command_option>
+#----------------------------------------------------------------------------
+smbd_start_options="-D"
+smbd_start="start-stop-daemon --start --exec /usr/sbin/smbd -- ${smbd_start_options}"
+smbd_stop="start-stop-daemon --stop --exec /usr/sbin/smbd"
+smbd_reload="killall -HUP smbd"
+
+nmbd_start_options="-D"
+nmbd_start="start-stop-daemon --start --exec /usr/sbin/nmbd -- ${nmbd_start_options}"
+nmbd_stop="start-stop-daemon --stop --exec /usr/sbin/nmbd"
+nmbd_reload="killall -HUP nmbd"
+
+samba4_start_options=""
+samba4_start="start-stop-daemon --start --exec /usr/sbin/samba -- ${samba4_start_options}"
+samba4_stop="start-stop-daemon --stop --exec /usr/sbin/samba"
+samba4_reload="killall -HUP samba"
+
+winbind_start_options=""
+winbind_start="start-stop-daemon --start --exec /usr/sbin/winbindd -- ${winbind_start_options}"
+winbind_stop="start-stop-daemon --stop --exec /usr/sbin/winbindd"
+winbind_reload="killall -HUP winbindd"
+
diff --git a/net-fs/samba/files/4.3/samba4.initd-r1 b/net-fs/samba/files/4.3/samba4.initd-r1
new file mode 100644
index 0000000..bf162ad
--- /dev/null
+++ b/net-fs/samba/files/4.3/samba4.initd-r1
@@ -0,0 +1,56 @@
+#!/sbin/openrc-run
+# Copyright 1999-2016 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License, v2 or later
+# $Id$
+
+extra_started_commands="reload"
+piddir="/run/samba"
+
+depend() {
+ after slapd
+ need net
+ use cupsd
+}
+
+DAEMONNAME="${SVCNAME##samba.}"
+[ "${DAEMONNAME}" != "samba" ] && daemon_list=${DAEMONNAME}
+
+signal_do() {
+ local signal="$1"
+ [ -z "${signal}" ] && return 0
+
+ local result=0 last_result=0 daemon= cmd_exec=
+ for daemon in ${daemon_list} ; do
+ eval cmd_exec=\$${daemon}_${signal}
+ if [ -n "${cmd_exec}" ]; then
+ ebegin "${my_service_name} -> ${signal}: ${daemon}"
+ #echo ${cmd} '->' ${!cmd}
+ ${cmd_exec} > /dev/null
+ last_result=$?
+ eend ${last_result}
+ fi
+ result=$(( ${result} + ${last_result} ))
+ done
+ return ${result}
+}
+
+start() {
+ ${my_service_PRE}
+ [ -d "${piddir}" ] || mkdir -p "${piddir}"
+ signal_do start && return 0
+
+ eerror "Error: starting services (see system logs)"
+ signal_do stop
+ return 1
+}
+stop() {
+ ${my_service_PRE}
+ if signal_do stop ; then
+ ${my_service_POST}
+ return 0
+ fi
+}
+reload() {
+ ${my_service_PRE}
+ signal_do reload
+}
diff --git a/net-fs/samba/files/nmbd.service b/net-fs/samba/files/nmbd.service
new file mode 100644
index 0000000..44b4ffb
--- /dev/null
+++ b/net-fs/samba/files/nmbd.service
@@ -0,0 +1,12 @@
+[Unit]
+Description=Samba NetBIOS name server
+After=network.target
+
+[Service]
+Type=forking
+PIDFile=/var/run/samba/nmbd.pid
+ExecStart=/usr/sbin/nmbd -D
+ExecReload=/bin/kill -HUP $MAINPID
+
+[Install]
+WantedBy=multi-user.target
diff --git a/net-fs/samba/files/samba-4.2.3-heimdal_compilefix.patch b/net-fs/samba/files/samba-4.2.3-heimdal_compilefix.patch
new file mode 100644
index 0000000..c6f5007
--- /dev/null
+++ b/net-fs/samba/files/samba-4.2.3-heimdal_compilefix.patch
@@ -0,0 +1,22 @@
+https://bugs.gentoo.org/542638
+
+From: Stephan Wolf <stephan@letzte-bankreihe.de>
+
+Samba uses the build in implementation of heimdal from year 2011.
+The ebuild uses the portage version of heimdal.
+I got it fixed to patch samba kdc_init function.
+
+--- samba-4.2.3/source4/kdc/kdc.c
++++ samba-4.2.3/source4/kdc/kdc.c
+@@ -967,9 +967,9 @@
+ * The old behavior in the _kdc_get_preferred_key()
+ * function is use_strongest_server_key=TRUE.
+ */
+- kdc->config->as_use_strongest_session_key = false;
++ kdc->config->tgt_use_strongest_session_key = false;
+ kdc->config->preauth_use_strongest_session_key = false;
+- kdc->config->tgs_use_strongest_session_key = false;
++ kdc->config->svc_use_strongest_session_key = false;
+ kdc->config->use_strongest_server_key = true;
+
+ /* Register hdb-samba4 hooks for use as a keytab */
diff --git a/net-fs/samba/files/samba-4.2.7-pam.patch b/net-fs/samba/files/samba-4.2.7-pam.patch
new file mode 100644
index 0000000..22b393e
--- /dev/null
+++ b/net-fs/samba/files/samba-4.2.7-pam.patch
@@ -0,0 +1,36 @@
+--- samba-4.2.7/source3/wscript
++++ samba-4.2.7/source3/wscript
+@@ -853,11 +853,11 @@
+ if not conf.CHECK_FUNCS_IN('iconv_open', 'iconv', headers='iconv.h'):
+ conf.env.with_iconv = False
+ if conf.env.with_iconv:
+ conf.DEFINE('HAVE_ICONV', 1)
+
+- if Options.options.with_pam:
++ if Options.options.with_pam != False:
+ use_pam=True
+ conf.CHECK_HEADERS('security/pam_appl.h pam/pam_appl.h')
+ if not conf.CONFIG_SET('HAVE_SECURITY_PAM_APPL_H') and not conf.CONFIG_SET('HAVE_PAM_PAM_APPL_H'):
+ Logs.warn("--with-pam=yes but pam_appl.h not found")
+ use_pam=False
+@@ -926,10 +926,20 @@
+ msg="Checking whether PAM_RADIO_TYPE is available");
+ if use_pam:
+ conf.DEFINE('WITH_PAM', 1)
+ conf.DEFINE('WITH_PAM_MODULES', 1)
+
++ else:
++ Logs.warn("PAM disabled")
++ use_pam=False
++ conf.undefine('WITH_PAM')
++ conf.undefine('WITH_PAM_MODULES')
++ conf.undefine('HAVE_SECURITY_PAM_APPL_H')
++ conf.undefine('PAM_RHOST')
++ conf.undefine('PAM_TTY')
++ conf.undefine('HAVE_PAM_PAM_APPL_H')
++
+ if Options.options.with_pam_smbpass:
+ conf.env.with_pam_smbpass = True
+
+ seteuid = False
+
diff --git a/net-fs/samba/files/samba.conf b/net-fs/samba/files/samba.conf
new file mode 100644
index 0000000..e0a6f32
--- /dev/null
+++ b/net-fs/samba/files/samba.conf
@@ -0,0 +1,2 @@
+D /run/samba 0755 root root
+D /run/lock/samba 0755 root root
diff --git a/net-fs/samba/files/samba.service b/net-fs/samba/files/samba.service
new file mode 100644
index 0000000..8214ff8
--- /dev/null
+++ b/net-fs/samba/files/samba.service
@@ -0,0 +1,10 @@
+[Unit]
+Description=Samba AD server
+After=network.target winbindd.service
+Conflicts=nmbd.service smbd.service
+
+[Service]
+ExecStart=/usr/sbin/samba --interactive
+
+[Install]
+WantedBy=multi-user.target
diff --git a/net-fs/samba/files/smbd.service b/net-fs/samba/files/smbd.service
new file mode 100644
index 0000000..5c006a4
--- /dev/null
+++ b/net-fs/samba/files/smbd.service
@@ -0,0 +1,12 @@
+[Unit]
+Description=Samba SMB/CIFS server
+After=network.target nmbd.service winbindd.service
+
+[Service]
+Type=forking
+PIDFile=/var/run/samba/smbd.pid
+ExecStart=/usr/sbin/smbd -D
+ExecReload=/bin/kill -HUP $MAINPID
+
+[Install]
+WantedBy=multi-user.target
diff --git a/net-fs/samba/files/smbd.socket b/net-fs/samba/files/smbd.socket
new file mode 100644
index 0000000..833bf43
--- /dev/null
+++ b/net-fs/samba/files/smbd.socket
@@ -0,0 +1,9 @@
+[Unit]
+Description=Samba SMB/CIFS server socket
+
+[Socket]
+ListenStream=445
+Accept=yes
+
+[Install]
+WantedBy=sockets.target
diff --git a/net-fs/samba/files/smbd_at.service b/net-fs/samba/files/smbd_at.service
new file mode 100644
index 0000000..e1f71be
--- /dev/null
+++ b/net-fs/samba/files/smbd_at.service
@@ -0,0 +1,7 @@
+[Unit]
+Description=Samba SMB/CIFS server instance
+
+[Service]
+ExecStart=/usr/sbin/smbd -F
+ExecReload=/bin/kill -HUP $MAINPID
+StandardInput=socket
diff --git a/net-fs/samba/files/winbindd.service b/net-fs/samba/files/winbindd.service
new file mode 100644
index 0000000..67a778f
--- /dev/null
+++ b/net-fs/samba/files/winbindd.service
@@ -0,0 +1,12 @@
+[Unit]
+Description=Samba Winbind daemon
+After=network.target nmbd.service
+
+[Service]
+Type=forking
+PIDFile=/var/run/samba/winbindd.pid
+ExecStart=/usr/sbin/winbindd -D
+ExecReload=/bin/kill -HUP $MAINPID
+
+[Install]
+WantedBy=multi-user.target
diff --git a/net-fs/samba/metadata.xml b/net-fs/samba/metadata.xml
new file mode 100644
index 0000000..73d475c
--- /dev/null
+++ b/net-fs/samba/metadata.xml
@@ -0,0 +1,32 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+ <maintainer type="project">
+ <email>samba@gentoo.org</email>
+ <name>Samba Team</name>
+ </maintainer>
+ <longdescription>
+ Samba is an Open Source/Free Software suite that provides seamless file and print services to SMB/CIFS clients. Integration with various accounting and antivirus backends. License: GNU General Public License.
+ </longdescription>
+ <use>
+ <flag name="addc">Enable Active Directory Domain Controller support</flag>
+ <flag name="ads">Enable Active Directory support</flag>
+ <flag name="swat">Enables support for swat configuration gui</flag>
+ <flag name="winbind">Enables support for the winbind auth daemon</flag>
+ <flag name="client">Enables the client part</flag>
+ <flag name="server">Enables the server part</flag>
+ <flag name="netapi">Enable building of netapi bits</flag>
+ <flag name="addns">Enable AD DNS integration</flag>
+ <flag name="aio">Enable asynchronous IO support</flag>
+ <flag name="cluster">Enable support for clustering</flag>
+ <flag name="dmapi">Enable support for DMAPI. This currently works only in combination with XFS.</flag>
+ <flag name="ldb">Enable the ldb tools</flag>
+ <flag name="quota">Enables support for user quotas</flag>
+ <flag name="smbclient">Enable smbclient tool</flag>
+ <flag name="smbsharemodes">Enable special smb share modes (?) </flag>
+ <flag name="smbtav2">Enable Samba Traffic Analyzer version 2 </flag>
+ <flag name="system-mitkrb5">Use <pkg>app-crypt/mit-krb5</pkg> instead of
+ <pkg>app-crypt/heimdal</pkg>.</flag>
+ <flag name="iprint">Enabling iPrint technology by Novell</flag>
+ </use>
+</pkgmetadata>
diff --git a/net-fs/samba/samba-4.3.9-r99.ebuild b/net-fs/samba/samba-4.3.9-r99.ebuild
new file mode 100644
index 0000000..f58f54d
--- /dev/null
+++ b/net-fs/samba/samba-4.3.9-r99.ebuild
@@ -0,0 +1,250 @@
+# Copyright 1999-2016 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=6
+PYTHON_COMPAT=( python2_7 )
+PYTHON_REQ_USE='threads(+),xml(+)'
+
+inherit python-single-r1 waf-utils multilib-minimal linux-info systemd eutils
+
+MY_PV="${PV/_rc/rc}"
+MY_P="${PN}-${MY_PV}"
+
+SRC_PATH="stable"
+[[ ${PV} = *_rc* ]] && SRC_PATH="rc"
+
+SRC_URI="mirror://samba/${SRC_PATH}/${MY_P}.tar.gz
+ https://dev.gentoo.org/~polynomial-c/samba-disable-python-patches-4.3.9.tar.xz"
+[[ ${PV} = *_rc* ]] || \
+KEYWORDS="~amd64 ~hppa ~x86"
+
+DESCRIPTION="Samba Suite Version 4"
+HOMEPAGE="http://www.samba.org/"
+LICENSE="GPL-3"
+
+SLOT="0"
+
+IUSE="acl addc addns ads aio avahi client cluster cups dmapi fam gnutls iprint
+ldap pam quota selinux syslog +system-mitkrb5 systemd test winbind"
+
+MULTILIB_WRAPPED_HEADERS=(
+ /usr/include/samba-4.0/policy.h
+ /usr/include/samba-4.0/dcerpc_server.h
+ /usr/include/samba-4.0/ctdb.h
+ /usr/include/samba-4.0/ctdb_client.h
+ /usr/include/samba-4.0/ctdb_protocol.h
+ /usr/include/samba-4.0/ctdb_private.h
+ /usr/include/samba-4.0/ctdb_typesafe_cb.h
+ /usr/include/samba-4.0/ctdb_version.h
+)
+
+# sys-apps/attr is an automagic dependency (see bug #489748)
+CDEPEND="${PYTHON_DEPS}
+ >=app-arch/libarchive-3.1.2[${MULTILIB_USEDEP}]
+ dev-lang/perl:=
+ dev-libs/libbsd[${MULTILIB_USEDEP}]
+ dev-libs/iniparser:0
+ dev-libs/popt[${MULTILIB_USEDEP}]
+ sys-libs/readline:=
+ virtual/libiconv
+ dev-python/subunit[${PYTHON_USEDEP},${MULTILIB_USEDEP}]
+ sys-apps/attr[${MULTILIB_USEDEP}]
+ sys-libs/libcap
+ >=sys-libs/ldb-1.1.24[${MULTILIB_USEDEP}]
+ sys-libs/ncurses:0=[${MULTILIB_USEDEP}]
+ >=sys-libs/talloc-2.1.3[python,${PYTHON_USEDEP},${MULTILIB_USEDEP}]
+ >=sys-libs/tdb-1.3.7[python,${PYTHON_USEDEP},${MULTILIB_USEDEP}]
+ >=sys-libs/tevent-0.9.25[${MULTILIB_USEDEP}]
+ sys-libs/zlib[${MULTILIB_USEDEP}]
+ virtual/pam
+ acl? ( virtual/acl )
+ addns? ( net-dns/bind-tools[gssapi] )
+ aio? ( dev-libs/libaio )
+ cluster? ( !dev-db/ctdb )
+ cups? ( net-print/cups )
+ dmapi? ( sys-apps/dmapi )
+ fam? ( virtual/fam )
+ gnutls? ( dev-libs/libgcrypt:0
+ >=net-libs/gnutls-1.4.0 )
+ ldap? ( net-nds/openldap[${MULTILIB_USEDEP}] )
+ system-mitkrb5? ( app-crypt/mit-krb5[${MULTILIB_USEDEP}] )
+ !system-mitkrb5? ( >=app-crypt/heimdal-1.5[-ssl,${MULTILIB_USEDEP}] )
+ systemd? ( sys-apps/systemd:0= )"
+DEPEND="${CDEPEND}
+ virtual/pkgconfig"
+RDEPEND="${CDEPEND}
+ client? ( net-fs/cifs-utils[ads?] )
+ selinux? ( sec-policy/selinux-samba )
+ !dev-perl/Parse-Yapp
+"
+
+REQUIRED_USE="addc? ( gnutls !system-mitkrb5 )
+ ads? ( acl gnutls ldap )
+ ${PYTHON_REQUIRED_USE}"
+
+S="${WORKDIR}/${MY_P}"
+
+PATCHES=(
+ "${FILESDIR}/${PN}-4.2.3-heimdal_compilefix.patch"
+ "${FILESDIR}/${PN}-4.2.7-pam.patch"
+)
+
+CONFDIR="${FILESDIR}/$(get_version_component_range 1-2)"
+
+WAF_BINARY="${S}/buildtools/bin/waf"
+
+SHAREDMODS=""
+
+pkg_setup() {
+ python-single-r1_pkg_setup
+ if use aio ; then
+ if ! linux_config_exists || ! linux_chkconfig_present AIO; then
+ ewarn "You must enable AIO support in your kernel config, "
+ ewarn "to be able to support asynchronous I/O. "
+ ewarn "You can find it at"
+ ewarn
+ ewarn "General Support"
+ ewarn " Enable AIO support "
+ ewarn
+ ewarn "and recompile your kernel..."
+ fi
+ fi
+ if use cluster ; then
+ SHAREDMODS="${SHAREDMODS}idmap_rid,idmap_tdb2,idmap_ad"
+ fi
+}
+
+src_prepare() {
+ default
+
+ # install the patches from tarball(s)
+ eapply "${WORKDIR}/patches/"
+
+ multilib_copy_sources
+}
+
+multilib_src_configure() {
+ local myconf=()
+ myconf=(
+ --enable-fhs
+ --sysconfdir=/etc
+ --localstatedir=/var
+ --with-modulesdir=/usr/$(get_libdir)/samba
+ --with-piddir=/run/${PN}
+ --bundled-libraries=NONE
+ --builtin-libraries=NONE
+ --disable-rpath
+ --disable-rpath-install
+ --nopyc
+ --nopyo
+ )
+ if multilib_is_native_abi ; then
+ myconf+=(
+ $(use_with acl acl-support)
+ $(usex addc '' '--without-ad-dc')
+ $(use_with addns dnsupdate)
+ $(use_with ads)
+ $(usex ads '--with-shared-modules=idmap_ad' '')
+ $(use_with aio aio-support)
+ $(use_enable avahi)
+ $(use_with cluster cluster-support)
+ $(use_enable cups)
+ $(use_with dmapi)
+ $(use_with fam)
+ $(use_enable gnutls)
+ $(use_enable iprint)
+ $(use_with ldap)
+ $(use_with pam)
+ $(use_with pam pam_smbpass)
+ $(usex pam "--with-pammodulesdir=/$(get_libdir)/security" '')
+ $(use_with quota quotas)
+ $(use_with syslog)
+ $(use_with systemd)
+ $(usex system-mitkrb5 '--with-system-mitkrb5' '')
+ $(use_with winbind)
+ $(usex test '--enable-selftest' '')
+ --with-shared-modules=${SHAREDMODS}
+ )
+ else
+ myconf+=(
+ --without-acl-support
+ --without-ad-dc
+ --without-dnsupdate
+ --without-ads
+ --without-aio-support
+ --disable-avahi
+ --without-cluster-support
+ --disable-cups
+ --without-dmapi
+ --without-fam
+ --disable-gnutls
+ --disable-iprint
+ $(use_with ldap)
+ --without-pam
+ --without-pam_smbpass
+ --without-quotas
+ --without-syslog
+ --without-systemd
+ $(usex system-mitkrb5 '--with-system-mitkrb5' '')
+ --without-winbind
+ --disable-python
+ )
+ fi
+
+ CPPFLAGS="-I${SYSROOT}/usr/include/et ${CPPFLAGS}" \
+ waf-utils_src_configure ${myconf[@]}
+}
+
+multilib_src_install() {
+ waf-utils_src_install
+
+ # Make all .so files executable
+ find "${D}" -type f -name "*.so" -exec chmod +x {} +
+
+ if multilib_is_native_abi; then
+ # install ldap schema for server (bug #491002)
+ if use ldap ; then
+ insinto /etc/openldap/schema
+ doins examples/LDAP/samba.schema
+ fi
+
+ # create symlink for cups (bug #552310)
+ if use cups ; then
+ dosym /usr/bin/smbspool /usr/libexec/cups/backend/smb
+ fi
+
+ # install example config file
+ insinto /etc/samba
+ doins examples/smb.conf.default
+
+ # Install init script and conf.d file
+ newinitd "${CONFDIR}/samba4.initd-r1" samba
+ newconfd "${CONFDIR}/samba4.confd" samba
+
+ systemd_dotmpfilesd "${FILESDIR}"/samba.conf
+ systemd_dounit "${FILESDIR}"/nmbd.service
+ systemd_dounit "${FILESDIR}"/smbd.{service,socket}
+ systemd_newunit "${FILESDIR}"/smbd_at.service 'smbd@.service'
+ systemd_dounit "${FILESDIR}"/winbindd.service
+ systemd_dounit "${FILESDIR}"/samba.service
+ fi
+}
+
+multilib_src_test() {
+ if multilib_is_native_abi ; then
+ "${WAF_BINARY}" test || die "test failed"
+ fi
+}
+
+pkg_postinst() {
+ ewarn "Be aware the this release contains the best of all of Samba's"
+ ewarn "technology parts, both a file server (that you can reasonably expect"
+ ewarn "to upgrade existing Samba 3.x releases to) and the AD domain"
+ ewarn "controller work previously known as 'samba4'."
+
+ elog "For further information and migration steps make sure to read "
+ elog "http://samba.org/samba/history/${P}.html "
+ elog "http://samba.org/samba/history/${PN}-4.2.0.html and"
+ elog "http://wiki.samba.org/index.php/Samba4/HOWTO "
+}